function initgame()
	math.randomseed(os.time())
	color.newColor()
	lvlscore = 0
	--Images
	ball = love.graphics.newImage("img/game/dot.png")
	balls = {}
	timer = {
		tick = 0
	}
	--Sound
	pop = love.audio.newSource("sound/pop.ogg", "static")
	--Initial balls
	for i=1, 20 do
		local x = math.random(screenWidth/4, screenWidth*0.85)
		local y = math.random(0, screenHeight*0.96)
		addBall(x, y, 255, 255, 255)
	end
	score = 0
	level = 1
	timeleft = 20
	--Powerups
	special = {
		boom = 1
	}
	boomcount = 0
	p1:setColors(0, 0, 0, 50, 0, 0, 0, 0)
	p2:setColors(0, 0, 0, 50, 0, 0, 0, 0)
	color.newColor()
end

function addBall(dx, dy, dr, dg, db)
	balls[#balls + 1] = {
		x = dx,
		y = dy,
		r = dr,
		g = dg,
		b = db,
		fuckoff = false
	}
end

function updategame(dt)
	if gamestate == "game" then
		if showpart then
			p1:update(dt)
			p2:update(dt)
		end
		timer.tick = timer.tick + 2 * dt
		if timer.tick > 2 then
			timeleft = timeleft - 1
			timer.tick = 0
			--Ball Adding
			for i=1, level do
				local x = math.random(screenWidth/4, screenWidth*0.85)
				local y = math.random(0, screenHeight*0.96)
				addBall(x, y, 255, 255, 255)
			end
		end
		--Hitcheck
		for i=1, #balls do
			if checkoverlap(love.mouse.getX(), love.mouse.getY(), 1, balls[i].x, balls[i].y, 20) then
				balls[i].fuckoff = true
				score = score + 1
				timeleft = timeleft + 0.5
				lvlscore = lvlscore + 1
				if not mute then 
					local i = math.random(0, 2)
					if i == 0 then
						pop:setPitch(0.9)
					elseif i == 1 then
						pop:setPitch(1.1)
					elseif i == 2 then
						pop:setPitch(1)
					end
					love.audio.stop()
					love.audio.play(pop) 
				end
				if lvlscore >= 20 then -- Level up
					level = level + 1
					lvlscore = 0
					color.newColor()
					--Special
					boomcount = boomcount + 1
					if boomcount == 5 then
						special.boom = special.boom + 1
						boomcount = 0
					end
				end
				break
			end
		end
		--Ball Removal
		for i=#balls, 1, -1 do
			if balls[i].fuckoff then
				table.remove(balls, i)
				break
			end
		end
		--Lost check
		if #balls >= 50 or timeleft < 0 then
			gamestate = "lost"
			initlost()
		end
		--No ball on screen bonus
		if #balls == 0 then
			score = score + 10 * dt
		end
		--Particles
		if showpart then
			local x = math.random(0, screenWidth)
			local y = math.random(0, screenHeight)
			p1:setPosition(x, y)
			local x2 = math.random(0, screenWidth)
			local y2 = math.random(0, screenHeight)
			p2:setPosition(x2, y2)
		end
	end
end

function love.keypressed(key)
	if key == "escape" then
		if gamestate == "game" then
			gamestate = "pause"
		elseif gamestate == "pause" then
			gamestate = "menu"
			initmenu()
		elseif gamestate == "lost" then
			gamestate = "menu"
			initmenu()
		end
	elseif key == " " then
		if gamestate == "lost" then
			gamestate = "game"
			initgame()
		elseif gamestate == "pause" then
			gamestate = "game"
		end
	elseif key == "m" then
		if mute then
			mute = false
		elseif not mute then
			mute = true
		end
	elseif key == "p" then
		if showpart then
			showpart = false
		elseif not showpart then
			showpart = true
		end
	end
end

function drawgame()
	if gamestate == "game" then
		local c = 10
		local i = 25
		if showpart then
			--love.graphics.setBlendMode("multiplicative")
			love.graphics.draw(p1)
			love.graphics.draw(p2)
		end
		love.graphics.setBlendMode("alpha")
		love.graphics.setFont(font.normal)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(fade, screenWidth/4, 0)
		love.graphics.draw(sidebar, 0, 0, 0, screenWidth/800, screenHeight/500)
		if timeleft >= 10 then
			love.graphics.setColor(255,255,255)
		elseif timeleft <= 10 and timeleft > 3 then
			love.graphics.setColor(255,140,0)
		elseif timeleft <= 3 then
			love.graphics.setColor(255,0,0)
		end
		love.graphics.print("Time: "..math.ceil(timeleft), 10, c)
		love.graphics.setColor(255,255,255)
		love.graphics.print("Score: "..math.floor(score), 10, c + i)
		love.graphics.print("Level: "..level, 10, c + (i*2))
		if #balls < 35 then
			love.graphics.setColor(255,255,255, 255)
		elseif #balls > 35 and #balls < 46 then
			love.graphics.setColor(255,140,0, 255)
		elseif #balls > 45 then
			love.graphics.setColor(255,0,0, 255)
		end
		love.graphics.printf("Balls: "..#balls, 0, 10, screenWidth,  "right")
		--Powerup Hud
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("Bombs: "..special.boom, 10, screenHeight*0.94)
		for i=1, #balls do
			love.graphics.setColor(balls[i].r, balls[i].g, balls[i].b)
			love.graphics.draw(ball, balls[i].x, balls[i].y)
		end
		if #balls > 45 then
			love.graphics.setColor(255,0,0)
			love.graphics.print("Too high ball count!", screenWidth*0.2625, 10)
		end
	elseif gamestate == "pause" then
		--GAME
			local c = 10
		local i = 25
		if showpart then
			--love.graphics.setBlendMode("multiplicative")
			love.graphics.draw(p1)
			love.graphics.draw(p2)
		end
		love.graphics.setBlendMode("alpha")
		love.graphics.setFont(font.normal)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(fade, screenWidth/4, 0, 0, screenWidth/800, screenHeight/500)
		love.graphics.draw(sidebar, 0, 0, 0, screenWidth/800, screenHeight/500)
		if timeleft >= 10 then
			love.graphics.setColor(255,255,255)
		elseif timeleft <= 10 and timeleft > 3 then
			love.graphics.setColor(255,140,0)
		elseif timeleft <= 3 then
			love.graphics.setColor(255,0,0)
		end
		love.graphics.print("Time: "..math.ceil(timeleft), 10, c)
		love.graphics.setColor(255,255,255)
		love.graphics.print("Score: "..math.floor(score), 10, c + i)
		love.graphics.print("Level: "..level, 10, c + (i*2))
		if #balls < 35 then
			love.graphics.setColor(255,255,255, 255)
		elseif #balls > 35 and #balls < 46 then
			love.graphics.setColor(255,140,0, 255)
		elseif #balls > 45 then
			love.graphics.setColor(255,0,0, 255)
		end
		love.graphics.printf("Balls: "..#balls, 0, 10, screenWidth,  "right")
		--Powerup Hud
		love.graphics.setColor(255, 255, 255)
		love.graphics.print("Bombs: "..special.boom, 10, screenHeight*0.94)
		for i=1, #balls do
			love.graphics.setColor(balls[i].r, balls[i].g, balls[i].b)
			love.graphics.draw(ball, balls[i].x, balls[i].y)
		end
		if #balls > 45 then
			love.graphics.setColor(255,0,0)
			love.graphics.print("Too high ball count!", screenWidth*0.2625, 10)
		end
		--Actual pause stuff
		love.graphics.setColor(0, 0, 0, 200)
		love.graphics.rectangle("fill", 0, 0, screenWidth, screenHeight)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.printf("Press space to return to game \n Press esc to return to main menu", 0, 10, screenWidth, "center")
	end
end

function checkoverlap(x1, y1, s1, x2, y2, s2)
	if x1 > (x2 + s2) or (x1 + s1) < x2 then return false end
	if y1 > (y2 + s2) or (y1 + s1) < y2 then return false end
	return true
end
--LOST
function initlost()
	love.graphics.setBackgroundColor(236,0,0)
end

function drawlost()
	if gamestate == "lost" then
		love.graphics.setFont(font.big)
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(bigfade)
		love.graphics.printf("Game Over", 0, 30, screenWidth, "center")
		love.graphics.setFont(font.normal)
		local tbonus = 0
		if timeleft <= 0 then tbonus = 0 else tbonus = timeleft end
		love.graphics.printf("You reached level "..level.." with the score "..math.floor(score), 0, screenHeight*0.16, screenWidth, "center")
		love.graphics.printf("Time Bonus: "..timeleft, 0, screenHeight*0.22, screenWidth, "center")
		love.graphics.setFont(font.big)
		love.graphics.printf("Your final score: "..math.floor(score + tbonus), 0, screenHeight*0.3, screenWidth, "center")
		love.graphics.setFont(font.normal)
		love.graphics.printf("Press ESC to return to menu or space to restart", 0, screenHeight/2, screenWidth, "center")
	end
end