function initmenu()
	color.newColor()
	p1:setColors(255, 255, 255, 50, 255, 255, 255, 0)
	p2:setColors(255, 255, 255, 50, 255, 255, 255, 0)
	menub = {
		{text = "Start", y = screenHeight/2, width = 0.0875*screenWidth, hover = false, a = 50},
		{text = "Options", y = screenHeight*0.6, width = 1/8*screenWidth, hover = false, a = 50},
		{text = "Exit", y = screenHeight*0.7, width = screenWidth*0.0625, hover = false, a = 50}
	}
	optb = { --Options buttons
		{text = "Sound: on", y = screenHeight/2, width = screenWidth*0.15625, hover = false, a = 50},
		{text = "Particles: on", y = screenHeight*0.6, width = screenWidth*0.19375, hover = false, a = 50},
		{text = "Back", y = screenHeight*0.8, width = screenWidth*0.06875, hover = false, a = 50}
	}
	bfadespeed = 1000 -- Button fade speed
	beep = love.audio.newSource("sound/beep.ogg", "static")
	beep:setVolume(0.5)
	menubg = love.graphics.newImage("img/gui/menubg.png")
	screen = "main" --main, options
end

function updatemenu(dt)
	mx, my = love.mouse.getPosition()
	if gamestate == "menu" then
		if showpart then
			p1:update(dt)
			p2:update(dt)
			local x = math.random(0, screenWidth)
			local y = math.random(0, screenHeight)
			p1:setPosition(x, y)
			local x2 = math.random(0, screenWidth)
			local y2 = math.random(0, screenHeight)
			p2:setPosition(x2, y2)
		end
		if screen == "main" then
			--Buttons hover
			for i=1, #menub do
				if CheckCollision(mx, my, 1, 1, screenWidth/2 - menub[i].width, menub[i].y, menub[i].width*2, screenHeight*0.08) then
					menub[i].hover = true
					if menub[i].a < 255 then
						menub[i].a = menub[i].a + bfadespeed * dt
					else
						menub[i].a = 255
					end
				else
					menub[i].hover = false
					if menub[i].a > 50 then
						menub[i].a = menub[i].a - bfadespeed * dt
					else
						menub[i].a = 50
					end
				end
			end
		elseif screen == "options" then
			for i=1, #optb do
				if CheckCollision(mx, my, 1, 1, screenWidth/2 - optb[i].width, optb[i].y, optb[i].width*2, screenHeight*0.08) then
					optb[i].hover = true
					if optb[i].a < 255 then
						optb[i].a = optb[i].a + bfadespeed * dt
					else
						optb[i].a = 255
					end
				else
					optb[i].hover = false
					if optb[i].a > 50 then
						optb[i].a = optb[i].a - bfadespeed * dt
					else
						optb[i].a = 50
					end
				end
			end
		end
	end
	if onbutton then
		love.audio.play(beep)
	end
end



function drawmenu()
	if gamestate == "menu" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(font.big)
		--Particles
		if showpart then
			love.graphics.setBlendMode("additive")
			love.graphics.draw(p1)
			love.graphics.draw(p2)
		end
		love.graphics.setBlendMode("alpha")
		love.graphics.draw(menubg)
		if screen == "main" then
		for i=1, #menub do
			love.graphics.setColor(255, 255, 255, menub[i].a)
			love.graphics.printf(menub[i].text, screenWidth*0.01875, menub[i].y, screenWidth, "center")
		end
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(bigfade)
		love.graphics.draw(logo, screenWidth/2 - 147.5, screenHeight*0.04)
		elseif screen == "options" then
			for i=1, #optb do
			love.graphics.setColor(255, 255, 255, optb[i].a)
			love.graphics.printf(optb[i].text, screenWidth*0.01875, optb[i].y, screenWidth, "center")
		end
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(bigfade)
		love.graphics.draw(logo, screenWidth/2 - 147.5, screenHeight*0.04)
		end
	end
end

function CheckCollision(x1, y1, w1, h1, x2, y2, w2, h2)
	if x1 > (x2 + w2) or (x1 + w1) < x2 then return false end
	if y1 > (y2 + h2) or (y1 + h1) < y2 then return false end
	return true
end